using System;
using System.Windows;
using System.Windows.Controls;
using SciChart.Charting3D.Model.DataSeries.Waterfall;
using SciChart.Examples.ExternalDependencies.Data;

namespace SciChart.Examples.Examples.Charts3D.CreateA3DChart
{
    /// <summary>
    /// Interaction logic for CreateAContouredChart.xaml
    /// </summary>
    public partial class CreateAWaterfall3DChart : UserControl
    {
        

        public CreateAWaterfall3DChart()
        {
            InitializeComponent();
            Loaded += OnLoaded;
        }

        private void OnLoaded(object sender, RoutedEventArgs routedEventArgs)
        {
            var pointsPerSlice = 49;
            var sliceCount = 1;
            var slicePositions = new float[sliceCount];

            

            var dataSeries = new WaterfallDataSeries3D<float>(pointsPerSlice, slicePositions)
            {
                SeriesName = "Waterfall",
                StartX = 0,
                StepX = 1,
                StartZ = 0,
                StepZ = 1
            };

            FillDataSeries(dataSeries, sliceCount, pointsPerSlice);
            WaterfallSeries.DataSeries = dataSeries;
        }

        private void FillDataSeries(WaterfallDataSeries3D<float> dataSeries, int sliceCount, int pointsPerSlice)
        {
            var xData = new float[49] {932.5f, 935, 937.5f, 940, 942.5f, 945,
                947.5f, 950, 952.5f, 955, 957.5f, 960, 962.5f, 965, 967.5f, 970, 972.5f,
                975, 977.5f, 980, 982.5f, 985, 987.5f, 990, 992.5f, 995, 997.5f, 1000, 1002.5f,
                1005, 1007.5f, 1010, 1012.5f, 1015, 1017.5f, 1020, 1022.5f, 1025, 1027.5f, 1030, 1032.5f,
                1035, 1037.5f, 1040, 1042.5f, 1045, 1047.5f, 1050, 1052.5f };

            var yData = new float[49] {-66.4265f, -66.63934f, -67.36121f, -67.54607f, -67.55759f, -67.56796f, -67.49272f, -67.34307f,
                                       -67.3857f, -67.06584f, -66.59779f, -66.62602f, -66.28419f, -66.10303f, -66.21245f, 50.95058f,
                50.95058f, 50.95058f, 50.95058f, 50.95058f, 50.95058f, 50.95058f, 50.95058f, 50.95058f, 50.95058f, 50.95058f, 50.95058f,
                50.95058f, 50.95058f, 50.95058f, 50.95058f, 50.95058f, 50.95058f, 50.95058f, 50.95058f, 50.95058f, 50.95058f, 50.60991f,
                50.60991f, 50.60991f, -66.78659f, -66.95386f, -66.83574f, -66.86031f, -66.72756f, -66.77839f,
                -66.73544f, -66.95539f, -66.68681f };

            for (int sliceIndex = 0; sliceIndex < sliceCount; ++sliceIndex)
            {
                
                for (var pointIndex = 0; pointIndex < pointsPerSlice; pointIndex++)
                {
                    dataSeries.InternalArray[0] = (xData);
                    dataSeries.SetRowAt(0, yData);
                }
            }
        }
    }
}